<html>
<head>
<title>OgreMesh.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMesh.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMesh_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Mesh_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Mesh_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVertexIndexData_8h.html">OgreVertexIndexData.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreVertexBoneAssignment_8h.html">OgreVertexBoneAssignment.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreSkeleton_8h.html">OgreSkeleton.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreAnimation_8h.html">OgreAnimation.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgreAnimationTrack_8h.html">OgreAnimationTrack.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="OgrePose_8h.html">OgrePose.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">namespace </span>Ogre {
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00088"></a>00088     <span class="keyword">struct </span>MeshLodUsage;
<a name="l00089"></a>00089     <span class="keyword">class </span>LodStrategy;
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classOgre_1_1Mesh.html">00091</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AnimationContainer.html" title="An animation container interface, which allows generic access to sibling animations.">AnimationContainer</a>
<a name="l00092"></a>00092     {
<a name="l00093"></a><a class="code" href="classOgre_1_1Mesh.html#a1d5fbbc16bf26f6a94d018b087d4db7e">00093</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>;
<a name="l00094"></a><a class="code" href="classOgre_1_1Mesh.html#a48305c54a01e0c7a3376ea0a077c467f">00094</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl.html" title="Internal implementation of Mesh reading / writing for the latest version of the .mesh format...">MeshSerializerImpl</a>;
<a name="l00095"></a><a class="code" href="classOgre_1_1Mesh.html#a307213f805148c370557044b8f6b00fe">00095</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl__v1__4.html" title="Class for providing backwards-compatibility for loading version 1.4 of the .mesh format.">MeshSerializerImpl_v1_4</a>;
<a name="l00096"></a><a class="code" href="classOgre_1_1Mesh.html#ae60e96165c5d5495195fa0d49f031372">00096</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl__v1__2.html" title="Class for providing backwards-compatibility for loading version 1.2 of the .mesh format.">MeshSerializerImpl_v1_2</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1Mesh.html#aef9901d67ded13a151aa3d4fde3a7b17">00097</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl__v1__1.html" title="Class for providing backwards-compatibility for loading version 1.1 of the .mesh format.">MeshSerializerImpl_v1_1</a>;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099     <span class="keyword">public</span>:
<a name="l00100"></a><a class="code" href="classOgre_1_1Mesh.html#a7d726e72a87c304798883fbecbe6810a">00100</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Real&gt;::type</a> <a class="code" href="classOgre_1_1Mesh.html#a7d726e72a87c304798883fbecbe6810a">LodValueList</a>;
<a name="l00101"></a><a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">00101</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;MeshLodUsage&gt;::type</a> <a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">MeshLodUsageList</a>;
<a name="l00103"></a><a class="code" href="classOgre_1_1Mesh.html#ad54314635e4616376964378a2a842368">00103</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1multimap.html">multimap&lt;size_t, VertexBoneAssignment&gt;::type</a> <a class="code" href="classOgre_1_1Mesh.html#ad54314635e4616376964378a2a842368" title="Multimap of vertex bone assignments (orders by vertex index)">VertexBoneAssignmentList</a>;
<a name="l00104"></a><a class="code" href="classOgre_1_1Mesh.html#a87ffd99faf08ec80bd6932ac77381f3f">00104</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;VertexBoneAssignmentList&gt;</a> <a class="code" href="classOgre_1_1Mesh.html#a87ffd99faf08ec80bd6932ac77381f3f">BoneAssignmentIterator</a>;
<a name="l00105"></a><a class="code" href="classOgre_1_1Mesh.html#a1f5c82cf71efd2c7490e600800dad53b">00105</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;SubMesh*&gt;::type</a> <a class="code" href="classOgre_1_1Mesh.html#a1f5c82cf71efd2c7490e600800dad53b">SubMeshList</a>;
<a name="l00106"></a><a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">00106</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;unsigned short&gt;::type</a> <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">IndexMap</a>;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108     <span class="keyword">protected</span>:
<a name="l00115"></a><a class="code" href="classOgre_1_1Mesh.html#a7ca5d3840b1139163678c69accd610e8">00115</a>         <a class="code" href="classOgre_1_1Mesh.html#a1f5c82cf71efd2c7490e600800dad53b">SubMeshList</a> <a class="code" href="classOgre_1_1Mesh.html#a7ca5d3840b1139163678c69accd610e8" title="A list of submeshes which make up this mesh.">mSubMeshList</a>;
<a name="l00116"></a>00116     
<a name="l00118"></a>00118         <span class="keywordtype">void</span> organiseTangentsBuffer(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *vertexData, 
<a name="l00119"></a>00119             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> targetSemantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index, 
<a name="l00120"></a>00120             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> sourceTexCoordSet);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="keyword">public</span>:
<a name="l00126"></a><a class="code" href="classOgre_1_1Mesh.html#a001584a126b2a78e15a2b3b9e9ee8433">00126</a>         <span class="keyword">typedef</span> HashMap&lt;String, ushort&gt; <a class="code" href="classOgre_1_1Mesh.html#a001584a126b2a78e15a2b3b9e9ee8433" title="A hashmap used to store optional SubMesh names.">SubMeshNameMap</a> ;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128         
<a name="l00129"></a>00129     <span class="keyword">protected</span>:
<a name="l00130"></a>00130 
<a name="l00131"></a><a class="code" href="classOgre_1_1Mesh.html#a2f1b62478038df7cae569fcf5d2b2d72">00131</a>         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> <a class="code" href="classOgre_1_1Mesh.html#a2f1b62478038df7cae569fcf5d2b2d72">mFreshFromDisk</a>;
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classOgre_1_1Mesh.html#a5e06f63dfac01346d8a045448af28407">00133</a>         <a class="code" href="classOgre_1_1Mesh.html#a001584a126b2a78e15a2b3b9e9ee8433" title="A hashmap used to store optional SubMesh names.">SubMeshNameMap</a> <a class="code" href="classOgre_1_1Mesh.html#a5e06f63dfac01346d8a045448af28407">mSubMeshNameMap</a> ;
<a name="l00134"></a>00134 
<a name="l00136"></a><a class="code" href="classOgre_1_1Mesh.html#a9786a87341b9b5954382f956749f598a">00136</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1Mesh.html#a9786a87341b9b5954382f956749f598a" title="Local bounding box volume.">mAABB</a>;
<a name="l00138"></a><a class="code" href="classOgre_1_1Mesh.html#afa81b36baa8be6c84ab68c8b949a28bb">00138</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Mesh.html#afa81b36baa8be6c84ab68c8b949a28bb" title="Local bounding sphere radius (centered on object)">mBoundRadius</a>;
<a name="l00139"></a>00139 
<a name="l00141"></a><a class="code" href="classOgre_1_1Mesh.html#abf86b0682730527681abfe665fa63f52">00141</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Mesh.html#abf86b0682730527681abfe665fa63f52" title="Optional linked skeleton.">mSkeletonName</a>;
<a name="l00142"></a><a class="code" href="classOgre_1_1Mesh.html#a1f273987d25be940aa9e4381b7984a67">00142</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> <a class="code" href="classOgre_1_1Mesh.html#a1f273987d25be940aa9e4381b7984a67">mSkeleton</a>;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144        
<a name="l00145"></a><a class="code" href="classOgre_1_1Mesh.html#aecb0a3ad72dfe057752755a3be9a9d62">00145</a>         <a class="code" href="classOgre_1_1Mesh.html#ad54314635e4616376964378a2a842368" title="Multimap of vertex bone assignments (orders by vertex index)">VertexBoneAssignmentList</a> <a class="code" href="classOgre_1_1Mesh.html#aecb0a3ad72dfe057752755a3be9a9d62">mBoneAssignments</a>;
<a name="l00146"></a>00146 
<a name="l00148"></a><a class="code" href="classOgre_1_1Mesh.html#ae36b7dbb1a019f7e74f7f7723e2f3b39">00148</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#ae36b7dbb1a019f7e74f7f7723e2f3b39" title="Flag indicating that bone assignments need to be recompiled.">mBoneAssignmentsOutOfDate</a>;
<a name="l00149"></a>00149 
<a name="l00151"></a>00151         <span class="keywordtype">void</span> buildIndexMap(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#ad54314635e4616376964378a2a842368" title="Multimap of vertex bone assignments (orders by vertex index)">VertexBoneAssignmentList</a>&amp; boneAssignments,
<a name="l00152"></a>00152             <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">IndexMap</a>&amp; boneIndexToBlendIndexMap, <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">IndexMap</a>&amp; blendIndexToBoneIndexMap);
<a name="l00154"></a>00154         <span class="keywordtype">void</span> compileBoneAssignments(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#ad54314635e4616376964378a2a842368" title="Multimap of vertex bone assignments (orders by vertex index)">VertexBoneAssignmentList</a>&amp; boneAssignments,
<a name="l00155"></a>00155             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> numBlendWeightsPerVertex, 
<a name="l00156"></a>00156             <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">IndexMap</a>&amp; blendIndexToBoneIndexMap,
<a name="l00157"></a>00157             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetVertexData);
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="classOgre_1_1Mesh.html#aaad417a45c64afe0db38fc0b39657cd4">00159</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a> *<a class="code" href="classOgre_1_1Mesh.html#aaad417a45c64afe0db38fc0b39657cd4">mLodStrategy</a>;
<a name="l00160"></a><a class="code" href="classOgre_1_1Mesh.html#a9b6f3fc61ca0d2d2672b47a16fc47fff">00160</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#a9b6f3fc61ca0d2d2672b47a16fc47fff">mIsLodManual</a>;
<a name="l00161"></a><a class="code" href="classOgre_1_1Mesh.html#a57579011f3db548f4d096735298b171d">00161</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1Mesh.html#a57579011f3db548f4d096735298b171d">mNumLods</a>;
<a name="l00162"></a><a class="code" href="classOgre_1_1Mesh.html#adf2df0fe279913f67a2fd07a01bc5263">00162</a>         <a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">MeshLodUsageList</a> <a class="code" href="classOgre_1_1Mesh.html#adf2df0fe279913f67a2fd07a01bc5263">mMeshLodUsageList</a>;
<a name="l00163"></a>00163 
<a name="l00164"></a><a class="code" href="classOgre_1_1Mesh.html#a50c4b46dec40e7433a9c3bd2a0349c59">00164</a>         <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> <a class="code" href="classOgre_1_1Mesh.html#a50c4b46dec40e7433a9c3bd2a0349c59">mVertexBufferUsage</a>;
<a name="l00165"></a><a class="code" href="classOgre_1_1Mesh.html#ae321765ebd25dfb980ea8fa749bb9195">00165</a>         <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> <a class="code" href="classOgre_1_1Mesh.html#ae321765ebd25dfb980ea8fa749bb9195">mIndexBufferUsage</a>;
<a name="l00166"></a><a class="code" href="classOgre_1_1Mesh.html#a4d241fb1ac0e9bb6d9d510a879296fd2">00166</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#a4d241fb1ac0e9bb6d9d510a879296fd2">mVertexBufferShadowBuffer</a>;
<a name="l00167"></a><a class="code" href="classOgre_1_1Mesh.html#abde99137ff08e231b5ae13217b8c876e">00167</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#abde99137ff08e231b5ae13217b8c876e">mIndexBufferShadowBuffer</a>;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a><a class="code" href="classOgre_1_1Mesh.html#a6f094394f60ba564ffc0e15998187481">00170</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#a6f094394f60ba564ffc0e15998187481">mPreparedForShadowVolumes</a>;
<a name="l00171"></a><a class="code" href="classOgre_1_1Mesh.html#a8e05383eefb4a20985626ae26f4676af">00171</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#a8e05383eefb4a20985626ae26f4676af">mEdgeListsBuilt</a>;
<a name="l00172"></a><a class="code" href="classOgre_1_1Mesh.html#ae82cdb664edcbebb241153913ff4ab12">00172</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#ae82cdb664edcbebb241153913ff4ab12">mAutoBuildEdgeLists</a>;
<a name="l00173"></a>00173 
<a name="l00175"></a><a class="code" href="classOgre_1_1Mesh.html#a51044e47a0544a177858c5a39aa06830">00175</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, Animation*&gt;::type</a> <a class="code" href="classOgre_1_1Mesh.html#a51044e47a0544a177858c5a39aa06830" title="Storage of morph animations, lookup by name.">AnimationList</a>;
<a name="l00176"></a><a class="code" href="classOgre_1_1Mesh.html#acac70b5bd5092cb00478bfc439e36c26">00176</a>         <a class="code" href="classOgre_1_1Mesh.html#a51044e47a0544a177858c5a39aa06830" title="Storage of morph animations, lookup by name.">AnimationList</a> <a class="code" href="classOgre_1_1Mesh.html#acac70b5bd5092cb00478bfc439e36c26">mAnimationsList</a>;
<a name="l00178"></a><a class="code" href="classOgre_1_1Mesh.html#a6c96921fb54638cedc2300fbe5ba50a2">00178</a>         <span class="keyword">mutable</span> <a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> <a class="code" href="classOgre_1_1Mesh.html#a6c96921fb54638cedc2300fbe5ba50a2" title="The vertex animation type associated with the shared vertex data.">mSharedVertexDataAnimationType</a>;
<a name="l00180"></a><a class="code" href="classOgre_1_1Mesh.html#a8f06141370faf0503f76f11809d961d6">00180</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#a8f06141370faf0503f76f11809d961d6" title="Whether vertex animation includes normals.">mSharedVertexDataAnimationIncludesNormals</a>;
<a name="l00182"></a><a class="code" href="classOgre_1_1Mesh.html#ad6fda574da726cc8861408341ab65261">00182</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#ad6fda574da726cc8861408341ab65261" title="Do we need to scan animations for animation types?">mAnimationTypesDirty</a>;
<a name="l00183"></a>00183 
<a name="l00185"></a><a class="code" href="classOgre_1_1Mesh.html#a828d80c76f0e26edb7ea699d1c919818">00185</a>         <a class="code" href="group__Animation.html#ga2320179c7d0107995d8a737c86a40333">PoseList</a> <a class="code" href="classOgre_1_1Mesh.html#a828d80c76f0e26edb7ea699d1c919818" title="List of available poses for shared and dedicated geometryPoseList.">mPoseList</a>;
<a name="l00186"></a><a class="code" href="classOgre_1_1Mesh.html#a204a433f12cbf81f3df251bd823dbbd5">00186</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#a204a433f12cbf81f3df251bd823dbbd5">mPosesIncludeNormals</a>;
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00194"></a>00194         <span class="keywordtype">void</span> prepareImpl(<span class="keywordtype">void</span>);
<a name="l00197"></a>00197         <span class="keywordtype">void</span> unprepareImpl(<span class="keywordtype">void</span>);
<a name="l00199"></a>00199         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00201"></a>00201         <span class="keywordtype">void</span> postLoadImpl(<span class="keywordtype">void</span>);
<a name="l00203"></a>00203         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00205"></a>00205         <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209     <span class="keyword">public</span>:
<a name="l00214"></a>00214         <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00215"></a>00215             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00216"></a>00216         ~<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>();
<a name="l00217"></a>00217 
<a name="l00218"></a>00218         <span class="comment">// NB All methods below are non-virtual since they will be</span>
<a name="l00219"></a>00219         <span class="comment">// called in the rendering loop - speed is of the essence.</span>
<a name="l00220"></a>00220 
<a name="l00227"></a>00227         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* createSubMesh(<span class="keywordtype">void</span>);
<a name="l00228"></a>00228 
<a name="l00231"></a>00231         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* createSubMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00232"></a>00232         
<a name="l00235"></a>00235         <span class="keywordtype">void</span> nameSubMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index);
<a name="l00236"></a>00236 
<a name="l00239"></a>00239         <span class="keywordtype">void</span> unnameSubMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00240"></a>00240         
<a name="l00246"></a>00246         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> _getSubMeshIndex(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00247"></a>00247 
<a name="l00250"></a>00250         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumSubMeshes(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00251"></a>00251 
<a name="l00254"></a>00254         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* getSubMesh(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00255"></a>00255 
<a name="l00258"></a>00258         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* getSubMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span> ;
<a name="l00259"></a>00259         
<a name="l00265"></a>00265         <span class="keywordtype">void</span> destroySubMesh(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00266"></a>00266 
<a name="l00272"></a>00272         <span class="keywordtype">void</span> destroySubMesh(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00273"></a>00273         
<a name="l00274"></a><a class="code" href="classOgre_1_1Mesh.html#ac3955099a61b444cb9a2e7e111a1f271">00274</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;SubMeshList&gt;</a> <a class="code" href="classOgre_1_1Mesh.html#ac3955099a61b444cb9a2e7e111a1f271">SubMeshIterator</a>;
<a name="l00276"></a><a class="code" href="classOgre_1_1Mesh.html#a1891dd7442acc39c7edbf6a064e61b70">00276</a>         <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">SubMeshIterator</a> getSubMeshIterator(<span class="keywordtype">void</span>)
<a name="l00277"></a>00277         { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">SubMeshIterator</a>(mSubMeshList.begin(), mSubMeshList.end()); }
<a name="l00278"></a>00278       
<a name="l00287"></a><a class="code" href="classOgre_1_1Mesh.html#a1fd9968ccd424f913a7f3f68639f3ecf">00287</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *<a class="code" href="classOgre_1_1Mesh.html#a1fd9968ccd424f913a7f3f68639f3ecf" title="Shared vertex data.">sharedVertexData</a>;
<a name="l00288"></a>00288 
<a name="l00309"></a><a class="code" href="classOgre_1_1Mesh.html#aa9a6fc00032943a35fd293b5c664929e">00309</a>         <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">IndexMap</a> <a class="code" href="classOgre_1_1Mesh.html#aa9a6fc00032943a35fd293b5c664929e" title="Shared index map for translating blend index to bone index.">sharedBlendIndexToBoneIndexMap</a>;
<a name="l00310"></a>00310 
<a name="l00320"></a>00320         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> clone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newGroup = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00321"></a>00321 
<a name="l00324"></a>00324         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBounds(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00325"></a>00325 
<a name="l00327"></a>00327         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingSphereRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00328"></a>00328 
<a name="l00337"></a>00337         <span class="keywordtype">void</span> _setBounds(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; bounds, <span class="keywordtype">bool</span> pad = <span class="keyword">true</span>);
<a name="l00338"></a>00338 
<a name="l00346"></a>00346         <span class="keywordtype">void</span> _setBoundingSphereRadius(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radius);
<a name="l00347"></a>00347 
<a name="l00358"></a>00358         <span class="keywordtype">void</span> setSkeletonName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName);
<a name="l00359"></a>00359 
<a name="l00361"></a>00361         <span class="keywordtype">bool</span> hasSkeleton(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00362"></a>00362 
<a name="l00365"></a>00365         <span class="keywordtype">bool</span> hasVertexAnimation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00366"></a>00366         
<a name="l00370"></a>00370         <span class="keyword">const</span> <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; getSkeleton(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00371"></a>00371 
<a name="l00373"></a>00373         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getSkeletonName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00378"></a>00378         <span class="keywordtype">void</span> _initAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00379"></a>00379 
<a name="l00384"></a>00384         <span class="keywordtype">void</span> _refreshAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00397"></a>00397         <span class="keywordtype">void</span> addBoneAssignment(<span class="keyword">const</span> <a class="code" href="structOgre_1_1VertexBoneAssignment__s.html" title="Records the assignment of a single vertex to a single bone with the corresponding weight...">VertexBoneAssignment</a>&amp; vertBoneAssign);
<a name="l00398"></a>00398 
<a name="l00404"></a>00404         <span class="keywordtype">void</span> clearBoneAssignments(<span class="keywordtype">void</span>);
<a name="l00405"></a>00405 
<a name="l00412"></a>00412         <span class="keywordtype">void</span> _notifySkeleton(<a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; pSkel);
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 
<a name="l00417"></a>00417         <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">BoneAssignmentIterator</a> getBoneAssignmentIterator(<span class="keywordtype">void</span>);
<a name="l00418"></a>00418 
<a name="l00421"></a><a class="code" href="classOgre_1_1Mesh.html#a749cfe5f7a2e9d5de27939ef237ff8b5">00421</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#ad54314635e4616376964378a2a842368" title="Multimap of vertex bone assignments (orders by vertex index)">VertexBoneAssignmentList</a>&amp; <a class="code" href="classOgre_1_1Mesh.html#a749cfe5f7a2e9d5de27939ef237ff8b5" title="Gets a const reference to the list of bone assignments.">getBoneAssignments</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mBoneAssignments; }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00428"></a>00428         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getNumLodLevels(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00430"></a>00430         <span class="keyword">const</span> <a class="code" href="structOgre_1_1MeshLodUsage.html" title="A way of recording the way each LODs is recorded this Mesh.">MeshLodUsage</a>&amp; getLodLevel(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index) <span class="keyword">const</span>;
<a name="l00444"></a>00444         <span class="keywordtype">void</span> createManualLodLevel(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; meshName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName = <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>());
<a name="l00445"></a>00445 
<a name="l00453"></a>00453         <span class="keywordtype">void</span> updateManualLodLevel(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; meshName);
<a name="l00454"></a>00454 
<a name="l00460"></a>00460         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getLodIndex(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value) <span class="keyword">const</span>;
<a name="l00461"></a>00461 
<a name="l00468"></a><a class="code" href="classOgre_1_1Mesh.html#af19a6a2ea5d033850fc575b2e9452d3d">00468</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#af19a6a2ea5d033850fc575b2e9452d3d" title="Returns true if this mesh is using manual LOD.">isLodManual</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIsLodManual; }
<a name="l00469"></a>00469 
<a name="l00471"></a>00471         <span class="keywordtype">void</span> _setLodInfo(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> numLevels, <span class="keywordtype">bool</span> isManual);
<a name="l00473"></a>00473         <span class="keywordtype">void</span> _setLodUsage(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level, <a class="code" href="structOgre_1_1MeshLodUsage.html" title="A way of recording the way each LODs is recorded this Mesh.">MeshLodUsage</a>&amp; usage);
<a name="l00475"></a>00475         <span class="keywordtype">void</span> _setSubMeshLodFaceList(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> subIdx, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> level, <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* facedata);
<a name="l00476"></a>00476 
<a name="l00478"></a>00478         <span class="keywordtype">void</span> removeLodLevels(<span class="keywordtype">void</span>);
<a name="l00479"></a>00479 
<a name="l00502"></a>00502         <span class="keywordtype">void</span> setVertexBufferPolicy(<a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> shadowBuffer = <span class="keyword">false</span>);
<a name="l00525"></a>00525         <span class="keywordtype">void</span> setIndexBufferPolicy(<a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> shadowBuffer = <span class="keyword">false</span>);
<a name="l00527"></a><a class="code" href="classOgre_1_1Mesh.html#a8e53e203cdf12cc40d746399e1f17c49">00527</a>         <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> <a class="code" href="classOgre_1_1Mesh.html#a8e53e203cdf12cc40d746399e1f17c49" title="Gets the usage setting for this meshes vertex buffers.">getVertexBufferUsage</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexBufferUsage; }
<a name="l00529"></a><a class="code" href="classOgre_1_1Mesh.html#a3402c383107c83903f42d165163ac9e1">00529</a>         <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> <a class="code" href="classOgre_1_1Mesh.html#a3402c383107c83903f42d165163ac9e1" title="Gets the usage setting for this meshes index buffers.">getIndexBufferUsage</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexBufferUsage; }
<a name="l00531"></a><a class="code" href="classOgre_1_1Mesh.html#aa662df545eb8df490864316667ce1da2">00531</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#aa662df545eb8df490864316667ce1da2" title="Gets whether or not this meshes vertex buffers are shadowed.">isVertexBufferShadowed</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexBufferShadowBuffer; }
<a name="l00533"></a><a class="code" href="classOgre_1_1Mesh.html#af91ff1e6396fc2aa6ca42ffeda910794">00533</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#af91ff1e6396fc2aa6ca42ffeda910794" title="Gets whether or not this meshes index buffers are shadowed.">isIndexBufferShadowed</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndexBufferShadowBuffer; }
<a name="l00534"></a>00534        
<a name="l00535"></a>00535 
<a name="l00549"></a>00549         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> _rationaliseBoneAssignments(<span class="keywordtype">size_t</span> vertexCount, VertexBoneAssignmentList&amp; assignments);
<a name="l00550"></a>00550 
<a name="l00558"></a>00558         <span class="keywordtype">void</span> _compileBoneAssignments(<span class="keywordtype">void</span>);
<a name="l00559"></a>00559 
<a name="l00565"></a>00565         <span class="keywordtype">void</span> _updateCompiledBoneAssignments(<span class="keywordtype">void</span>);
<a name="l00566"></a>00566 
<a name="l00593"></a>00593         <span class="keywordtype">void</span> buildTangentVectors(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> targetSemantic = <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da57d43012049b3ec7b4240b207dd029f2" title="Tangent (X axis if normal is Z)">VES_TANGENT</a>,
<a name="l00594"></a>00594             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> sourceTexCoordSet = 0, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0, 
<a name="l00595"></a>00595             <span class="keywordtype">bool</span> splitMirrored = <span class="keyword">false</span>, <span class="keywordtype">bool</span> splitRotated = <span class="keyword">false</span>, <span class="keywordtype">bool</span> storeParityInW = <span class="keyword">false</span>);
<a name="l00596"></a>00596 
<a name="l00615"></a>00615         <span class="keywordtype">bool</span> suggestTangentVectorBuildParams(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> targetSemantic,
<a name="l00616"></a>00616             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>&amp; outSourceCoordSet, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>&amp; outIndex);
<a name="l00617"></a>00617 
<a name="l00621"></a>00621         <span class="keywordtype">void</span> buildEdgeList(<span class="keywordtype">void</span>);
<a name="l00623"></a>00623         <span class="keywordtype">void</span> freeEdgeList(<span class="keywordtype">void</span>);
<a name="l00624"></a>00624 
<a name="l00643"></a>00643         <span class="keywordtype">void</span> prepareForShadowVolume(<span class="keywordtype">void</span>);
<a name="l00644"></a>00644 
<a name="l00651"></a>00651         <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* getEdgeList(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> lodIndex = 0);
<a name="l00652"></a>00652 
<a name="l00659"></a>00659         <span class="keyword">const</span> <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* getEdgeList(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> lodIndex = 0) <span class="keyword">const</span>;
<a name="l00660"></a>00660 
<a name="l00663"></a><a class="code" href="classOgre_1_1Mesh.html#a349d98f2e2668dfa630075123af7e90c">00663</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#a349d98f2e2668dfa630075123af7e90c" title="Returns whether this mesh has already had it&#39;s geometry prepared for use in rendering shadow volumes...">isPreparedForShadowVolumes</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPreparedForShadowVolumes; }
<a name="l00664"></a>00664 
<a name="l00666"></a><a class="code" href="classOgre_1_1Mesh.html#ab54aeef34c76386d3b42c88ba42eb69c">00666</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#ab54aeef34c76386d3b42c88ba42eb69c" title="Returns whether this mesh has an attached edge list.">isEdgeListBuilt</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mEdgeListsBuilt; }
<a name="l00667"></a>00667 
<a name="l00679"></a>00679         <span class="keyword">static</span> <span class="keywordtype">void</span> prepareMatricesForVertexBlend(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>** blendMatrices,
<a name="l00680"></a>00680             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* boneMatrices, <span class="keyword">const</span> IndexMap&amp; indexMap);
<a name="l00681"></a>00681 
<a name="l00700"></a>00700         <span class="keyword">static</span> <span class="keywordtype">void</span> softwareVertexBlend(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* sourceVertexData, 
<a name="l00701"></a>00701             <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetVertexData,
<a name="l00702"></a>00702             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* <span class="keyword">const</span>* blendMatrices, <span class="keywordtype">size_t</span> numMatrices,
<a name="l00703"></a>00703             <span class="keywordtype">bool</span> blendNormals);
<a name="l00704"></a>00704 
<a name="l00717"></a>00717         <span class="keyword">static</span> <span class="keywordtype">void</span> softwareVertexMorph(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t, 
<a name="l00718"></a>00718             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; b1, 
<a name="l00719"></a>00719             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; b2, 
<a name="l00720"></a>00720             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetVertexData);
<a name="l00721"></a>00721 
<a name="l00737"></a>00737         <span class="keyword">static</span> <span class="keywordtype">void</span> softwareVertexPoseBlend(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight, 
<a name="l00738"></a>00738             <span class="keyword">const</span> <a class="code" href="structOgre_1_1map.html">map&lt;size_t, Vector3&gt;::type</a>&amp; vertexOffsetMap,
<a name="l00739"></a>00739             <span class="keyword">const</span> <a class="code" href="structOgre_1_1map.html">map&lt;size_t, Vector3&gt;::type</a>&amp; normalsMap,
<a name="l00740"></a>00740             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetVertexData);
<a name="l00742"></a><a class="code" href="classOgre_1_1Mesh.html#adf1de56b022a41ca399588951c7bb1c2">00742</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a001584a126b2a78e15a2b3b9e9ee8433" title="A hashmap used to store optional SubMesh names.">SubMeshNameMap</a>&amp; <a class="code" href="classOgre_1_1Mesh.html#adf1de56b022a41ca399588951c7bb1c2" title="Gets a reference to the optional name assignments of the SubMeshes.">getSubMeshNameMap</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSubMeshNameMap; }
<a name="l00743"></a>00743 
<a name="l00754"></a><a class="code" href="classOgre_1_1Mesh.html#ac4f3cb35c7eebbe35d5734c8e3682c7d">00754</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Mesh.html#ac4f3cb35c7eebbe35d5734c8e3682c7d" title="Sets whether or not this Mesh should automatically build edge lists when asked for them...">setAutoBuildEdgeLists</a>(<span class="keywordtype">bool</span> autobuild) { mAutoBuildEdgeLists = autobuild; }
<a name="l00759"></a><a class="code" href="classOgre_1_1Mesh.html#ac799c7cc93cb9a7f36427207767dfaa6">00759</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#ac799c7cc93cb9a7f36427207767dfaa6" title="Sets whether or not this Mesh should automatically build edge lists when asked for them...">getAutoBuildEdgeLists</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAutoBuildEdgeLists; }
<a name="l00760"></a>00760 
<a name="l00763"></a>00763         <span class="keyword">virtual</span> <a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> getSharedVertexDataAnimationType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00764"></a>00764 
<a name="l00766"></a><a class="code" href="classOgre_1_1Mesh.html#abe8d2374fa0a14726412723287945b3b">00766</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#abe8d2374fa0a14726412723287945b3b" title="Returns whether animation on shared vertex data includes normals.">getSharedVertexDataAnimationIncludesNormals</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSharedVertexDataAnimationIncludesNormals; }
<a name="l00767"></a>00767 
<a name="l00772"></a>00772         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* createAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length);
<a name="l00773"></a>00773 
<a name="l00777"></a>00777         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00778"></a>00778 
<a name="l00783"></a>00783         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* _getAnimationImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00784"></a>00784 
<a name="l00786"></a>00786         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00787"></a>00787 
<a name="l00789"></a>00789         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00790"></a>00790 
<a name="l00792"></a>00792         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumAnimations(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00793"></a>00793 
<a name="l00796"></a>00796         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00797"></a>00797 
<a name="l00799"></a>00799         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllAnimations(<span class="keywordtype">void</span>);
<a name="l00805"></a>00805         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* getVertexDataByTrackHandle(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00817"></a>00817         <span class="keywordtype">void</span> updateMaterialForAllSubMeshes(<span class="keywordtype">void</span>);
<a name="l00818"></a>00818 
<a name="l00823"></a>00823         <span class="keywordtype">void</span> _determineAnimationTypes(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00825"></a><a class="code" href="classOgre_1_1Mesh.html#aaa46f04cb1ba0263ac8c09b0b614a75c">00825</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Mesh.html#aaa46f04cb1ba0263ac8c09b0b614a75c" title="Are the derived animation types out of date?">_getAnimationTypesDirty</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAnimationTypesDirty; }
<a name="l00826"></a>00826 
<a name="l00833"></a>00833         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>* createPose(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00835"></a><a class="code" href="classOgre_1_1Mesh.html#a76dd3ef52e65e59b69abc55030674bc2">00835</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Mesh.html#a76dd3ef52e65e59b69abc55030674bc2" title="Get the number of poses.">getPoseCount</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPoseList.size(); }
<a name="l00837"></a>00837         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>* getPose(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index);
<a name="l00839"></a>00839         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>* getPose(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00843"></a>00843         <span class="keywordtype">void</span> removePose(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index);
<a name="l00847"></a>00847         <span class="keywordtype">void</span> removePose(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00849"></a>00849         <span class="keywordtype">void</span> removeAllPoses(<span class="keywordtype">void</span>);
<a name="l00850"></a>00850 
<a name="l00851"></a><a class="code" href="classOgre_1_1Mesh.html#a78f32e7c485e681dce9422b69186960f">00851</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">VectorIterator&lt;PoseList&gt;</a> <a class="code" href="classOgre_1_1Mesh.html#a78f32e7c485e681dce9422b69186960f">PoseIterator</a>;
<a name="l00852"></a><a class="code" href="classOgre_1_1Mesh.html#a1c651712526bfe4999f27c6c18ded1d9">00852</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;PoseList&gt;</a> <a class="code" href="classOgre_1_1Mesh.html#a1c651712526bfe4999f27c6c18ded1d9">ConstPoseIterator</a>;
<a name="l00853"></a>00853 
<a name="l00855"></a>00855         <a class="code" href="classOgre_1_1VectorIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying container.">PoseIterator</a> getPoseIterator(<span class="keywordtype">void</span>);
<a name="l00857"></a>00857         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstPoseIterator</a> getPoseIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00859"></a>00859         <span class="keyword">const</span> <a class="code" href="group__Animation.html#ga2320179c7d0107995d8a737c86a40333">PoseList</a>&amp; getPoseList(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00860"></a>00860 
<a name="l00862"></a>00862         <span class="keyword">const</span> <a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a> *getLodStrategy() <span class="keyword">const</span>;
<a name="l00864"></a>00864         <span class="keywordtype">void</span> setLodStrategy(<a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a> *lodStrategy);
<a name="l00865"></a>00865 
<a name="l00866"></a>00866     };
<a name="l00867"></a>00867 
<a name="l00874"></a><a class="code" href="classOgre_1_1MeshPtr.html">00874</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;Mesh&gt; 
<a name="l00875"></a>00875     {
<a name="l00876"></a>00876     <span class="keyword">public</span>:
<a name="l00877"></a><a class="code" href="classOgre_1_1MeshPtr.html#abbec119ed3bb38b54bb66e38f2ea2b1c">00877</a>         <a class="code" href="classOgre_1_1MeshPtr.html#abbec119ed3bb38b54bb66e38f2ea2b1c">MeshPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>&gt;() {}
<a name="l00878"></a><a class="code" href="classOgre_1_1MeshPtr.html#a2f1add9de3a418de7ba564491697b93e">00878</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1MeshPtr.html#a2f1add9de3a418de7ba564491697b93e">MeshPtr</a>(<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>&gt;(rep) {}
<a name="l00879"></a><a class="code" href="classOgre_1_1MeshPtr.html#a4fdd20db6401f38a40b1ebfe6c97ab9b">00879</a>         <a class="code" href="classOgre_1_1MeshPtr.html#a4fdd20db6401f38a40b1ebfe6c97ab9b">MeshPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Mesh.html">Mesh</a>&gt;(r) {} 
<a name="l00880"></a>00880         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r);
<a name="l00882"></a>00882         <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r);
<a name="l00883"></a>00883     <span class="keyword">protected</span>:
<a name="l00885"></a>00885         <span class="keywordtype">void</span> destroy(<span class="keywordtype">void</span>);
<a name="l00886"></a>00886     };
<a name="l00887"></a>00887 
<a name="l00889"></a><a class="code" href="structOgre_1_1MeshLodUsage.html">00889</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1MeshLodUsage.html" title="A way of recording the way each LODs is recorded this Mesh.">MeshLodUsage</a>
<a name="l00890"></a>00890     {
<a name="l00895"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#a114e1bc321b7b64f5bc931a30fea4dfe">00895</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1MeshLodUsage.html#a114e1bc321b7b64f5bc931a30fea4dfe" title="User-supplied values used to determine when th is lod applies.">userValue</a>;
<a name="l00896"></a>00896 
<a name="l00902"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#a67335e7b36a1f60c1ccddfba3f34775a">00902</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1MeshLodUsage.html#a67335e7b36a1f60c1ccddfba3f34775a" title="Value used by to determine when this lod applies.">value</a>;
<a name="l00903"></a>00903         
<a name="l00905"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#a7fb356beacea9effe6462ef8b14d5f72">00905</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1MeshLodUsage.html#a7fb356beacea9effe6462ef8b14d5f72" title="Only relevant if mIsLodManual is true, the name of the alternative mesh to use.">manualName</a>;
<a name="l00907"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#ad6ca3c9c1b8751a122a0e9002e008bfb">00907</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1MeshLodUsage.html#ad6ca3c9c1b8751a122a0e9002e008bfb" title="Only relevant if mIsLodManual is true, the name of the group of the alternative mesh.">manualGroup</a>;
<a name="l00909"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#a5749654233531c2be7509f795321504f">00909</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> <a class="code" href="structOgre_1_1MeshLodUsage.html#a5749654233531c2be7509f795321504f" title="Hard link to mesh to avoid looking up each time.">manualMesh</a>;
<a name="l00911"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#ae42184abf768e9c0cf42458112f2c082">00911</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* <a class="code" href="structOgre_1_1MeshLodUsage.html#ae42184abf768e9c0cf42458112f2c082" title="Edge list for this LOD level (may be derived from manual mesh)">edgeData</a>;
<a name="l00912"></a>00912 
<a name="l00913"></a><a class="code" href="structOgre_1_1MeshLodUsage.html#aa6c486dd152f254906b4b4ad11676ef3">00913</a>         <a class="code" href="structOgre_1_1MeshLodUsage.html#aa6c486dd152f254906b4b4ad11676ef3">MeshLodUsage</a>() : <a class="code" href="structOgre_1_1MeshLodUsage.html#a114e1bc321b7b64f5bc931a30fea4dfe" title="User-supplied values used to determine when th is lod applies.">userValue</a>(0.0), <a class="code" href="structOgre_1_1MeshLodUsage.html#a67335e7b36a1f60c1ccddfba3f34775a" title="Value used by to determine when this lod applies.">value</a>(0.0), <a class="code" href="structOgre_1_1MeshLodUsage.html#ae42184abf768e9c0cf42458112f2c082" title="Edge list for this LOD level (may be derived from manual mesh)">edgeData</a>(0) {}
<a name="l00914"></a>00914     };
<a name="l00915"></a>00915 
<a name="l00920"></a>00920 } <span class="comment">// namespace</span>
<a name="l00921"></a>00921 
<a name="l00922"></a>00922 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
